#if !defined(H_StrUtils_H)
    #define H_StrUtils_H

inline HRESULT StrDup(wchar_t** a_pwsOut,const wchar_t* a_wsIn)
{
	if (!a_pwsOut)
		return E_POINTER;	// Unable to return pointer

	if (!a_wsIn)
	{	*a_pwsOut=0;
		return S_OK;	// Return null
	}
	
	*a_pwsOut=(wchar_t*)CoTaskMemAlloc((wcslen(a_wsIn)+1)*sizeof(wchar_t));
	if (!*a_pwsOut)
		return E_OUTOFMEMORY;

	if(!wcscpy(*a_pwsOut, a_wsIn))
		return E_FAIL;

	return S_OK;
}

inline HRESULT StrFree(wchar_t** a_pwsInOut)
{
	if (!a_pwsInOut)
		return E_POINTER;	// Unable to adjust pointer

	if (!*a_pwsInOut)
		return S_OK;	// Already null
	
	CoTaskMemFree(*a_pwsInOut);

	*a_pwsInOut=0;

	return S_OK;
}

#endif
